% Mesh of a rectangle located in a given range.  An unstructured mesh.
%
% function [fens,gcells] = t3block2du(Length,Width,nL,nW,options)
%
% Range =<0,Length> x <0,Width>
% Divided into triangular (t3) elements: nL, nW in the first, second (x,y).
% This function  produces an unstructured mesh.
% options = Attributes recognized by the constructor of gcell_T3.
% 
% See the visual gallery by running test_block
% 
function [fens,gcells] = t3block2du(Length,Width,nL,nW,options)
    if ~isstruct(options)
        other_dimension = options; clear options;
        options.other_dimension = other_dimension;
    end
    a=sqrt(2)/2;
    a=1;
    [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
            ['curve 1 line 0 0 ' num2str(nL) ' 0'],...
            ['curve 2 line ' num2str(nL) ' 0 ' num2str(nL) ' ' num2str(nW)],...
            ['curve 3 line ' num2str(nL) ' ' num2str(nW) ' 0 ' num2str(nW)],...
            ['curve 4 line 0 ' num2str(nW) ' 0 0'],...
            ['curve 11 line 0 0 ' num2str(nL/2) ' ' num2str(nW/2)],...
            ['curve 21 line ' num2str(nL) ' 0 ' num2str(nL/2) ' ' num2str(nW/2)],...
            ['curve 31 line ' num2str(nL) ' ' num2str(nW) ' ' num2str(nL/2) ' ' num2str(nW/2)],...
            ['curve 41 line 0 ' num2str(nW) ' ' num2str(nL/2) ' ' num2str(nW/2)],...
            ['subregion 1  property 1 boundary  1  2 3 4 11 -11 21 -21 31 -31 41 -41'],...
            ['m-ctl-point constant 1.0']
            }, options.other_dimension,options);
     fens = transform_apply(fens,@(x,d)(x.*[Length/nL,Width/nW]), {});   
end
% [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
%             ['curve 1 line 0 0 ' num2str(nL) ' 0'],...
%             ['curve 2 line ' num2str(nL) ' 0 ' num2str(nL) ' ' num2str(nW)],...
%             ['curve 3 line ' num2str(nL) ' ' num2str(nW) ' 0 ' num2str(nW)],...
%             ['curve 4 line 0 ' num2str(nW) ' 0 0'],...
%             ['fixed 1 xy ' num2str(nL/2) ' ' num2str(nW/2)],...
%             ['fixed 11 xy ' num2str(a) ' ' num2str(a)],...
%             ['fixed 22 xy ' num2str(nL-a) ' ' num2str(a)],...
%             ['fixed 33 xy ' num2str(nL-a) ' ' num2str(nW-a)],...
%             ['fixed 44 xy ' num2str(a) ' ' num2str(nW-a)],...
%             ['subregion 1  property 1 boundary  1  2 3 4'],...
%             ['m-ctl-point constant 1.0']
%             }, options.other_dimension,options);
%      
